// LobeStudyDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LobeStudy.h"
#include "LobeStudyDlg.h"
#include <algorithm>
#include <functional>
#include <vector>
#include <sstream>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLobeStudyDlg dialog

CLobeStudyDlg::CLobeStudyDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLobeStudyDlg::IDD, pParent),
	fSession(0),
	fTimerHandle(0),
	fDisconnected(TRUE)
{
	//{{AFX_DATA_INIT(CLobeStudyDlg)
	fExcludeGroup = -1;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	fLobeMap.insert(LobeMap::value_type("Drive", (Lobe*)new DriveLobe));
	fLobeMap.insert(LobeMap::value_type("Stimulus Source", (Lobe*)new StimulusSourceLobe));
	fLobeMap.insert(LobeMap::value_type("Verb", (Lobe*)new VerbLobe));
	fLobeMap.insert(LobeMap::value_type("Noun", (Lobe*)new NounLobe));
	fLobeMap.insert(LobeMap::value_type("General Sensory", (Lobe*)new SensoryLobe));
	fLobeMap.insert(LobeMap::value_type("Decision", (Lobe*)new DecisionLobe));
	fLobeMap.insert(LobeMap::value_type("Attention", (Lobe*)new AttentionLobe));
}

CLobeStudyDlg::~CLobeStudyDlg()
{
	delete fSession;
	LobeMap::iterator first = fLobeMap.begin();
	LobeMap::iterator last = fLobeMap.end();
	while(first != last)
	{
		delete (*first).second;
		++first;
	}
	fLobeMap.clear();
}

void CLobeStudyDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLobeStudyDlg)
	DDX_Control(pDX, IDC_IT_STATIC, fItStatic);
	DDX_Control(pDX, IDC_LOBE_COMBOBOX, fLobeCombobox);
	DDX_Control(pDX, IDOK, fCloseButton);
	DDX_Control(pDX, IDC_DISCONNECT_BUTTON, fDisconnectButton);
	DDX_Control(pDX, IDC_DATA_LISTBOX, fDataListbox);
	DDX_Control(pDX, IDC_CONNECT_BUTTON, fConnectButton);
	DDX_Radio(pDX, IDC_OUTPUT_RADIO, fExcludeGroup);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLobeStudyDlg, CDialog)
	//{{AFX_MSG_MAP(CLobeStudyDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONNECT_BUTTON, OnConnectButton)
	ON_BN_CLICKED(IDC_DISCONNECT_BUTTON, OnDisconnectButton)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLobeStudyDlg message handlers

BOOL CLobeStudyDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	ResetButtons();

	LobeMap::iterator first = fLobeMap.begin();
	LobeMap::iterator last = fLobeMap.end();
	while(first != last)
	{
		fLobeCombobox.SetItemDataPtr(fLobeCombobox.AddString((*first).first.c_str()), (*first).second);
		++first;
	}

	fLobeCombobox.SetCurSel(0);
	fExcludeGroup = 0;
	UpdateData(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CLobeStudyDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CLobeStudyDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CLobeStudyDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CLobeStudyDlg::OnConnectButton() 
{
	// TODO: Add your control notification handler code here
	try
	{
		fDisconnected = FALSE;
		fSession = new Creatures::Session();
		ResetButtons();
		StartTimer();
	}
	catch(Creatures::DDEException&)
	{ 
		MessageBox("An error occurred trying to connect to Creatures.\nPlease ensure that Creatures is running and a norn is selected.",
			"Unable to connect");
	}
}

void CLobeStudyDlg::ResetButtons()
{
	if(fSession)
	{
		fConnectButton.EnableWindow(FALSE);
		fDisconnectButton.EnableWindow(TRUE);
		fCloseButton.EnableWindow(FALSE);
	}
	else
	{
		fConnectButton.EnableWindow(TRUE);
		fDisconnectButton.EnableWindow(FALSE);
		fCloseButton.EnableWindow(TRUE);
	}
}

void CLobeStudyDlg::OnDisconnectButton() 
{
	// TODO: Add your control notification handler code here
	fDisconnected = TRUE;
	StopTimer();
	delete fSession;
	fSession = 0;
	ResetButtons();
}

void CLobeStudyDlg::StartTimer()
{
	if(fTimerHandle != 0)
		StopTimer();

	fTimerHandle = SetTimer(1, 100, 0);
	if(fTimerHandle == 0)
	{
		MessageBox("Unable to start timer");
	}

}

void CLobeStudyDlg::StopTimer()
{
	if(fTimerHandle != 0)
	{
		if(!KillTimer(1))
		{
			MessageBox("Unable to stop timer");
		}
		fTimerHandle = 0;
	}
}

void CLobeStudyDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if(fDisconnected)
		return;

	try
	{
		StopTimer();
		UpdateData(TRUE);

		// Get lobe to query from combobox and execute the macro
		Lobe* lobe = (Lobe*)fLobeCombobox.GetItemDataPtr(fLobeCombobox.GetCurSel());
		std::string result = fSession->executeMacro(lobe->getMacroCommand().c_str());

		// The result of the macro call is parsed into a vector
		Lobe::CellVector all_data = lobe->parseCellData(result);
		UpdateIt();

		// Remove all data the has output or state value of zero depending
		// upon user selection.
		all_data.erase(std::remove_if(all_data.begin(), all_data.end(), fExcludeGroup == 0 ? outputIsZero : stateIsZero), all_data.end());

		// Sort remaining data by output or state depending upon selection.
		std::sort(all_data.begin(), all_data.end(), fExcludeGroup == 0 ? outputIsGreater : stateIsGreater);

		// Extract data from result
		fDataListbox.ResetContent();
		if(all_data.empty())
		{
			fDataListbox.AddString("Nothing");
		}
		Lobe::CellVector::iterator first = all_data.begin();
		Lobe::CellVector::iterator last = all_data.end();
		while(first != last)
		{
			LobeData data = (*first);

			std::ostringstream stream;
			stream << lobe->getCellDescription(data.fCell)
				   << " ("
				   << data.getOutput() << "/" << data.getState()
				   << ")"
				   << std::ends;
			fDataListbox.AddString(stream.str().c_str());	
			first++;
		}
		CDialog::OnTimer(nIDEvent);
		if(!fDisconnected)
			StartTimer();
	}
	catch(Creatures::DDEException&)
	{
		MessageBox("A DDE error has occurred", "Error", MB_OK);
		OnDisconnectButton();
	}
}

void CLobeStudyDlg::UpdateIt()
{
#if 0
	Lobe* lobe = fLobeMap["Verb"];
	std::string result = fSession->executeMacro("inst,dde: cell 3 10 0,endm");
	fItStatic.SetWindowText(result.c_str());
#endif
	Lobe* lobe = fLobeMap["Attention"];
	std::string result = fSession->executeMacro("inst,targ attn dde: putv neid targ norn,endm");
	fItStatic.SetWindowText(lobe->getCellDescription(atoi(result.c_str())).c_str());
}
