// LobeStudyDlg.h : header file
//
#include <string>
#include <map>
#include <Creatures/CreaturesConversation.h>
#include <Creatures/Brain.h>

#pragma warning (disable: 4786)

/////////////////////////////////////////////////////////////////////////////
// CLobeStudyDlg dialog

class CLobeStudyDlg : public CDialog
{
// Construction
public:
	CLobeStudyDlg(CWnd* pParent = NULL);	// standard constructor
	~CLobeStudyDlg();
	Creatures::Session* fSession;
	UINT fTimerHandle;
	BOOL fDisconnected;

	typedef std::map<std::string, Lobe*> LobeMap;
	LobeMap fLobeMap;
	
	void ResetButtons();
	void StartTimer();
	void StopTimer();
	void UpdateIt();

// Dialog Data
	//{{AFX_DATA(CLobeStudyDlg)
	enum { IDD = IDD_LOBESTUDY_DIALOG };
	CStatic	fItStatic;
	CComboBox	fLobeCombobox;
	CButton	fCloseButton;
	CButton	fDisconnectButton;
	CListBox	fDataListbox;
	CButton	fConnectButton;
	int		fExcludeGroup;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLobeStudyDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CLobeStudyDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnConnectButton();
	afx_msg void OnDisconnectButton();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
